Subject: RE: WebDAV property schema lookup

From: "Clemm, Geoff" <[email-masked]>
Date: Sun, 7 Apr 2002 21:59:05 -0400

From: Gary Cowan [mailto:[email-masked]]

   This situation illustrates a fundamental weakness with WebDAV in
   respect to enterprise document management systems. The WebDAV
   philosophy assumes that the client is controlling the properties of
   a resource/document and the server mearly acts as a store for the
   property information.

That is incorrect.  WebDAV explicitly supports both "dead" (client-defined)
and "live" (server-defined) properties.

   Wheras a DM server maintains extensive metadata for a given
   resource especially when vertical market applications have been
   built on top of the DM system.

Yes, WebDAV was designed with this in mind.

   WebDAV does not provide a methodology by which this metadata can be
   exposed.

Perhaps you could explain what you have in mind as "a methodology
by which this metadata can be exposed"?

   As such DM systems must still construct proprietary client
   applications causing users to perform authoring in the authoring
   tool while performing DM specific actions in the DM client.

As is the case for versioning systems.  To deal with this problem, we
defined an interoperable set of live properties (and a few new
methods) to provide authoring tools with a mechanism for interacting
with a wide range of versioning systems.  The WebDAV protocol proved
to be very amenable to this kind of extension.

   At this point in time it still makes more sense for DM systems to
   construct tight integration mechanisms within the context of the
   authoring application. This gives the DM system the ability expose
   its own metadata to the user during document creation/editing.

Yes, until you agreed on an interoperable set of DM live properties,
each client will need a custom integration with each server.

   WebDAV is a very attractive protocol but this one limitation is
inhibiting
   its extensive use within the enterprise DM community. 

The only group that could define an interoperable set of properties
for enterprise DM is the enterprise DM community itself.  I encourage
you to do so.

Cheers,
Geoff

---

From: Nupur Bhasin <[email-masked]>
Date: Mon, 8 Apr 2002 13:54:14 +0530

How do we unsubscribe from this list.Any clues please?

-----Original Message-----
From: Julian Reschke [mailto:[email-masked]]
Sent: Monday, April 08, 2002 1:17 PM
To: Dylan Barrell; Gary Cowan; DAV; 'Clemm, Geoff'
Subject: RE: WebDAV property schema lookup

> From: [email-masked]
> [mailto:[email-masked]]On Behalf Of Dylan Barrell
> Sent: Sunday, April 07, 2002 11:28 PM
> To: Gary Cowan; DAV; 'Clemm, Geoff'
> Subject: RE: WebDAV property schema lookup
>
>
> Absolutely agree - I brought this issue up a couple of months ago.
>
> >From my perspective we need two things
>
> 1) We need the ability for the server to enforce schema on documents when
> they are created (we talked about a multi-put a couple of months back).

Two thoughts:

a) MS Sharepoint works around this by enforcing schema compliance not on
creation, but upon CHECKIN. This may or may not be sufficient (checking in
pops up a dialogue where the user must fill all required fields).

b) Instead of inventing MULTIPUT, we may be able to use the HTTP Extension
Framework (RFC2774), defining mandatory headers for M-PUT (marshalling would
be a bit tricky, though).

> Schema descovery is also an issue as the client needs to know what the
> mandatory properties are before it can issue the multi-put.

Sure. But we won't get that unless a group of peope sits down and develops a
proposal.

> 2) We need to have a way for the server to tell the client where
> to redirect
> the user if the user want to manipulate the object in a way that is out of
> scope for WebDAV - e.g. initiate a chat with the author of the
> document. In
> fact, the server should be able to tell the client what URL to go to for
> these actions as well as what client side application to spawn
> should it be
> available.

In the general case, wouldn't that be just a link to a (dynamically
generated) HTML document (may be a new property or another use for
DAV:source :-).

---

From: Gary Cowan <[email-masked]>
Date: Mon, 8 Apr 2002 13:24:30 -0400

Fair enough

-----Original Message-----
From: Julian Reschke [mailto:[email-masked]]
Sent: Monday, April 08, 2002 1:14 PM
To: Gary Cowan; DAV
Subject: RE: WebDAV property schema lookup

> [mailto:[email-masked]]On Behalf Of Gary Cowan
> Sent: Monday, April 08, 2002 6:53 PM
> To: 'Clemm, Geoff'; DAV
> Server defined(live) properties are supported in that they can be queried,
> but there is no methodology that allows users to manipulate these
> properties
> >from disparate WebDAV clients.

Well, there is. What you don't have is an interoperable  way to *discover*
them (and their datatypes, descriptions).

> One of the characteristics of most if not all enterprise DM
> systems is that
> they are highly customizable. Thus the metadata properties for documents
> managed by the system can and quite often due change from site to
> site, and
> obviously change from industry to industry. For instance a law
> firm requires
> different metadata properties than a manufacturing firm.

Thus one needs a generic schema-based protocol that allows discovery of
mandatory properties and their types. This is what Microsoft Sharepoint
already implements.

> I suppose the holy grail would be to have WebDAV clients
> construct a dynamic
> properties dialog. This may not be practical in which case a redirection
> mechanism or a UI container such as a browser window could
> possibly be used.
> I am just thinking off the top of my head right now. I understand this is
> not an easy issue to resolve. If it can be resolved then WebDAV could
> potentially completely replace hardwired integration with desktop
> applications.

It certainly can be solved (without changing WebDAV), but it requires a lot
of work.

> From: Clemm, Geoff [mailto:[email-masked]]
> Sent: Sunday, April 07, 2002 9:59 PM
> To: DAV